/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package unikl.disco.math.functions;

import java.awt.Color;
import javax.swing.JDialog;
import javax.swing.JFrame;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.labels.StandardXYToolTipGenerator;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;
import unikl.disco.nc.gui.CurveDataset;
import unikl.disco.nc.gui.CurveRenderer;

/**
 *
 * @author ngollan
 */
public class FunctionPlot extends JDialog {
	private XYSeriesCollection dataset;
        private XYPlot plot;

	public FunctionPlot(final String title) {
		super();
		setTitle(title);

		dataset = new CurveDataset();
		final JFreeChart chart = createChart(dataset);
		final ChartPanel chartPanel = new ChartPanel(chart);
		chartPanel.setPreferredSize(new java.awt.Dimension(500, 270));
		setContentPane(chartPanel);

		setModal(true);
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		pack();
	}

	public void addSeries(XYSeries s) {
		dataset.addSeries(s);
	}

	private JFreeChart createChart(final XYDataset dataset) {
		NumberAxis xAxis = new NumberAxis("x");
		xAxis.setAutoRangeIncludesZero(false);
		xAxis.setStandardTickUnits(NumberAxis.createIntegerTickUnits());

		NumberAxis yAxis = new NumberAxis("y");

		final XYLineAndShapeRenderer renderer = new CurveRenderer();
		plot = new XYPlot(dataset, xAxis, yAxis, renderer);

		plot.setOrientation(PlotOrientation.VERTICAL);
		if(true) {
			renderer.setBaseToolTipGenerator(new StandardXYToolTipGenerator());
		}

		JFreeChart chart = new JFreeChart("DNC Plot Demo",
				JFreeChart.DEFAULT_TITLE_FONT, plot, true);

		chart.setBackgroundPaint(Color.white);

		plot = chart.getXYPlot();
		plot.setBackgroundPaint(Color.white);
		plot.setDomainGridlinePaint(Color.lightGray);
		plot.setRangeGridlinePaint(Color.lightGray);

		return chart;
	}
        
        public XYPlot getPlot() {
            return plot;
        }
}
